import type { Node, NodeType, ResolvedPos } from 'prosemirror-model';
import { Selection, TextSelection, NodeSelection, Command } from 'prosemirror-state';
import type { NodeWithPos } from 'prosemirror-utils';
export declare const isTextSelection: (selection: Selection) => selection is TextSelection;
export declare const isNodeSelection: (selection: Selection) => selection is NodeSelection;
export declare const isWholeSelection: (selection: Selection) => boolean;
export declare const get$Cursor: (selection: Selection) => ResolvedPos | null;
export declare const equalNodeType: (nodeType: NodeType[] | NodeType, node: Node) => boolean;
export declare const findSelectedNodeOfType: (nodeType: NodeType) => (selection: Selection) => {
    node: Node;
    pos: number;
    depth: number;
} | null;
export declare const createFakeParagraphNear: (direction: 'up' | 'down', parent?: NodeWithPos) => Command;
